package io.gitlab.jfronny.libjf;

import io.gitlab.jfronny.commons.log.Logger;
import io.gitlab.jfronny.commons.serialize.gson.api.GsonHolder;
import io.gitlab.jfronny.gson.GsonBuilder;
import io.gitlab.jfronny.libjf.coprocess.CoProcessManager;
import io.gitlab.jfronny.libjf.gson.GsonAdapter;;
import io.gitlab.jfronny.libjf.gson.HiddenAnnotationExclusionStrategy;
import net.fabricmc.api.ModInitializer;
import net.fabricmc.loader.api.FabricLoader;

public class LibJf implements ModInitializer {
    public static final String MOD_ID = "libjf";
    public static final Logger LOGGER = Logger.forName(MOD_ID);

    static {
        GsonHolder.modifyBuilder((final GsonBuilder builder) -> {
            builder.setOmitQuotes();
            for (GsonAdapter adapter : FabricLoader.getInstance().getEntrypoints(MOD_ID + ":gson_adapter", GsonAdapter.class)) {
                adapter.apply(builder);
            }
        });
        HiddenAnnotationExclusionStrategy.register();
        GsonHolder.register();
    }

    @Override
    public void onInitialize() {
        Logger.resetFactory();
    }
}
