package io.gitlab.jfronny.libjf.translate.impl;

import io.gitlab.jfronny.libjf.config.api.v1.*;
import io.gitlab.jfronny.libjf.config.api.v1.dsl.DSL;

public class TranslateConfig implements JfCustomConfig {
    public static Translator translationService = Translator.Google;
    public static String libreTranslateHost = "https://translate.argosopentech.com";

    public static void ensureValid() {
        if (translationService == null) translationService = Translator.Google;
        if (translationService == Translator.LibreTranslate && libreTranslateHost == null || libreTranslateHost.isBlank())
            libreTranslateHost = "https://translate.argosopentech.com";
    }

    @Override
    public void register(DSL.Defaulted dsl) {
    }

    public enum Translator {
        Google, LibreTranslate, Noop
    }

    static {
        DSL.create("libjf-translate-v1").register(b -> b
                .value("translationService", translationService, Translator.class, () -> translationService, v -> translationService = v)
                .value("libreTranslateHost", libreTranslateHost, () -> libreTranslateHost, v -> libreTranslateHost = v)
                .addVerifier(TranslateConfig::ensureValid)
        );
    }
}
